package com.jiuqi.util.crypto;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.jiuqi.util.JqLib;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.Provider;
import java.security.Security;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

public class DESUtil {
  private static final String Algorithm = "DES";
  
  public static final SecretKey generateKey() {
    try {
      Class<?> jceClass = Class.forName("com.sun.crypto.provider.SunJCE");
      Security.addProvider((Provider)jceClass.newInstance());
      KeyGenerator keygen = KeyGenerator.getInstance("DES");
      return keygen.generateKey();
    } catch (NoSuchAlgorithmException ex) {
      ex.printStackTrace();
      return null;
    } catch (Exception ex) {
      ex.printStackTrace();
      return null;
    } 
  }
  
  public static final SecretKey transKey(String keyHexStr) {
    try {
      DESKeySpec dks = new DESKeySpec(JqLib.hexStringToBytes(keyHexStr));
      SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
      SecretKey key = keyFactory.generateSecret(dks);
      return key;
    } catch (Exception ex) {
      ex.printStackTrace();
      return null;
    } 
  }
  
  public static final byte[] encrypt(SecretKey deskey, byte[] buff) {
    byte[] cipherByte = (byte[])null;
    try {
      Cipher c = Cipher.getInstance("DES");
      c.init(1, deskey);
      cipherByte = c.doFinal(buff);
    } catch (NoSuchPaddingException ex) {
      ex.printStackTrace();
    } catch (NoSuchAlgorithmException ex) {
      ex.printStackTrace();
      return null;
    } catch (InvalidKeyException ex) {
      ex.printStackTrace();
    } catch (BadPaddingException ex) {
      ex.printStackTrace();
    } catch (IllegalBlockSizeException ex) {
      ex.printStackTrace();
    } 
    return cipherByte;
  }
  
  public static final String decrypt(SecretKey deskey, byte[] buff) {
    byte[] cipherByte = (byte[])null;
    try {
      Cipher c = Cipher.getInstance("DES");
      c.init(2, deskey);
      cipherByte = c.doFinal(buff);
    } catch (NoSuchPaddingException ex) {
      ex.printStackTrace();
    } catch (NoSuchAlgorithmException ex) {
      ex.printStackTrace();
    } catch (InvalidKeyException ex) {
      ex.printStackTrace();
    } catch (BadPaddingException ex) {
      ex.printStackTrace();
    } catch (IllegalBlockSizeException ex) {
      ex.printStackTrace();
    } 
    return new String(cipherByte);
  }
}
